Terrier IR Platform - Terabyte Retriever v5.9
---------------------------------------------
![Terrier Maven CI](https://github.com/terrier-org/terrier-core/workflows/Terrier%20Maven%20CI/badge.svg) [![Maven Central](https://maven-badges.herokuapp.com/maven-central/org.terrier/terrier-platform/badge.svg)](https://maven-badges.herokuapp.com/maven-central/org.terrier/terrier-platform) 

:mag: [Terrier](http://terrier.org) is a highly flexible, efficient, and effective open source search engine, readily deployable on large-scale collections of documents. Terrier implements state-of-the-art indexing and retrieval functionalities, and provides an ideal platform for the rapid development and evaluation of large-scale retrieval applications.

Terrier is open source, and is a comprehensive, flexible and transparent platform for research and experimentation in text retrieval. [Research can easily be carried out](https://github.com/terrier-org/terrier-core/blob/5.x/doc/bibliography.md) on standard [TREC](http://trec.nist.gov/) and [CLEF](http://www.clef-initiative.eu/) test collections.

:coffee: Terrier is written in Java, and is developed at the School of Computing Science, [University of Glasgow](http://www.gla.ac.uk/).

The latest version of Terrier can be found at https://github.com/terrier-org/terrier-core/

:new: :snake: New in 2020, Terrier has Python bindings called [PyTerrier](https://github.com/terrier-org/pyterrier). PyTerrier allows experiments to be conducted in a succinct, declarative manner, including in Jupyter or Colab notebooks, while benefiting from the flexibility of Terrier.

### Open Source Licence

:green_book: Terrier is subject to the terms detailed in the Mozilla Public License Version 1.1. The Mozilla Public License can be found in the file
[LICENSE.txt](LICENSE.txt) or at the URL http://www.mozilla.org/MPL/MPL-1.1.html. By using this software, you have agreed to the licence.

### Citation Licence

The source and binary forms of Terrier are subject to the following citation license: 

:page_facing_up:  By downloading Terrier, you agree to cite at least one of [these four papers](https://github.com/terrier-org/terrier-core/blob/5.x/doc/bibliography.md) describing Terrier in any kind of material you produce where Terrier was used to conduct search or experimentation, whether be it a research paper, dissertation, article, poster, presentation, or documentation. For more information on publications concerning Terrier, see the Terrier Bibliography [here](https://github.com/terrier-org/terrier-core/blob/5.x/doc/bibliography.md). By using this software, you have agreed to the
citation licence.

### Getting Started

:fast_forward: In order to start [experimenting with Terrier](https://github.com/terrier-org/terrier-core/blob/5.x/doc/quickstart_experiments.md) or [developing new applications with Terrier](https://github.com/terrier-org/terrier-core/blob/5.x/doc/quickstart-integratedsearch.md), we recommend starting from the [quickstart documentation](https://github.com/terrier-org/terrier-core/blob/5.x/doc/index.md). 

### Other Resources
* :books: The full documentation of Terrier can also be found on the offical [website](http://terrier.org/). 
* :beetle: Bug reports, question or requests for new features can be posted on the [issue tracker](https://github.com/terrier-org/terrier-core/issues).
* :octocat: More information about PyTerrier can be found at its [Github repo](https://github.com/terrier-org/pyterrier).

------------------------
> Webpage: <http://terrier.org>  
> Contact: [School of Computing Science](http://www.dcs.gla.ac.uk/)  
> Copyright (C) 2004-2024 [University of Glasgow](http://www.gla.ac.uk/). All Rights Reserved. 
