/*
 * Terrier - Terabyte Retriever 
 * Webpage: http://terrier.org/
 * Contact: terrier{a.}dcs.gla.ac.uk
 * University of Glasgow - School of Computing Science
 * http://www.gla.ac.uk/
 * 
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Original Code is FSADocumentIndexInMemFields.java
 *
 * The Original Code is Copyright (C) 2020-2020 the University of Glasgow.
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Craig Macdonald <craigm{a.}dcs.gla.ac.uk> (original contributor)
 */
package org.terrier.structures;
import java.io.IOException;

/** A version of FSADocumentIndexInMem for indices with fields. */
public class FSADocumentIndexInMemFields extends FSADocumentIndexInMem implements FieldDocumentIndex {

    int[][] fieldLengths;
    public FSADocumentIndexInMemFields(IndexOnDisk index, String structureName) throws IOException {
        super(index, structureName);
        for(int i=0;i<this.size();i++) {
            fieldLengths[i] = ((FieldDocumentIndexEntry)this.get(i)).getFieldLengths();
        }
    }

    /** 
	 * {@inheritDoc} 
	 */
	public int[] getFieldLengths(int docid) {
		return fieldLengths[docid];
	}
}